//+------------------------------------------------------------------+
//|                                               Ambler Gambler.mq4 |
//|                                    Copyright  2007, Ryan Klefas |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Ryan Klefas (Base 1.7)"
#property link      "rklefas@inbox.com"



extern string    basic="==== Basic Settings ====";
extern double    TakeProfit=20;
       double    Stoploss=0;        // Automatically Calculated
extern double    Lots=0.1;

extern string    lot="==== Lot Sizing ====";
extern bool      Martingale=true;
extern int       MartingaleMultiplier=2; 
       bool      InvertedMartingale=false;

extern string    account="==== Account Settings ====";
extern int       MinimumEquity=0;
extern int       MinimumBalance=0;

extern string    activity="==== EA Activity Settings ====";
       bool      DisableClosingOrders=true;
extern bool      DisableNewOrders=false;

extern string    id="==== Identity Settings ====";
extern int       magicNum=12612;
extern string    shortName="Ambler Gambler";


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
   int allOrders=0, buyOrders=0, sellOrders=0, buyPending=0, sellPending=0;
   checkOrderStatus(allOrders,buyOrders,sellOrders,buyPending,sellPending);


//+------------------------------------------------------------------+
//| variable and indicator declaration                               |
//+------------------------------------------------------------------+



   double Spread = (Ask-Bid)/Point;
   Stoploss = TakeProfit + Spread + Spread;



//+------------------------------------------------------------------+
//| close existing orders under apprpriate conditions                |
//+------------------------------------------------------------------+
   if (DisableClosingOrders==false && allOrders>0)  {
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+





   // CODE FOR CLOSING EXISTING ORDERS


    
      
      
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
      }
//+------------------------------------------------------------------+
//| create new orders                                                |
//+------------------------------------------------------------------+
   if (newOrderPrevention(allOrders)==false)  {
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+



   if (allOrders==0)
   {
      sendBuyOrder();
      sendSellOrder();
   }




//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

      }
   return(0);
  }
  
//+------------------------------------------------------------------+
//| middle-man modules                                               |
//+------------------------------------------------------------------+

void sendBuyOrder() // Standard Version 1.7
{ versatileOrderTaker(1, Ask); }
   
//+------------------------------------------------------------------+

void sendSellOrder() // Standard Version 1.7
{ versatileOrderTaker(2, Bid); }

//+------------------------------------------------------------------+





//+------------------------------------------------------------------+
//| modules and functions                                            |
//+------------------------------------------------------------------+

 // Standard Version 1.7
void checkOrderStatus(int& allOrders,int& buyOrders,int& sellOrders,int& buyPending, int& sellPending)
{
   for(int cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ( orderBelongsToMe() )
      {  
         if (OrderType()==OP_BUY)
            {buyOrders++; allOrders++;}
         else if (OrderType()==OP_SELL)
            {sellOrders++; allOrders++;}
         else if (OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
            {buyPending++; allOrders++;}
         else if (OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
            {sellPending++; allOrders++;}
      }
   }
}

//+------------------------------------------------------------------+

bool orderBelongsToMe() // Standard Version 1.7
{
   if (OrderSymbol()==Symbol() && OrderMagicNumber()==simpleMagicGenerator() )
       return (true);
   else
      return (false);
}

//+------------------------------------------------------------------+

int simpleMagicGenerator() 
{
   return (magicNum);
}

//+------------------------------------------------------------------+

string commentString() 
{
   return (shortName);
}

//+------------------------------------------------------------------+

double lotMaker(int simpleType) // Custom Version 1.7
{

// Log history for easy access by Lot Calculators

   int myHistoryTotal=0;

   if (Martingale)
   {
      int cnt, total = OrdersHistoryTotal();
   
      if (total>0)
      {
   
         int historyPosition[1];
         int historyWinLoss[1];
         double historyLotSize[1];

         for(cnt=0;cnt<total;cnt++)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
            
               if ( orderBelongsToMe() )
                  {myHistoryTotal++;}
         }

         ArrayResize(historyPosition, myHistoryTotal);
         ArrayResize(historyLotSize, myHistoryTotal);
         ArrayResize(historyWinLoss, myHistoryTotal);
         ArrayInitialize(historyPosition,0);
         ArrayInitialize(historyLotSize,0);
         ArrayInitialize(historyWinLoss,99);
         int positionCounter = myHistoryTotal-1;

if (positionCounter<0)
   positionCounter=0;

   int doubler = -1;
   int reducer = 1;

   if (InvertedMartingale)
      {doubler = 1;
      reducer = -1;}

         for(cnt=0;cnt<total;cnt++)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);

            if ( orderBelongsToMe() )
            {
               historyPosition[positionCounter] = cnt;
               historyLotSize[positionCounter]=OrderLots();

               if (OrderClosePrice()==OrderTakeProfit())
                  {
                  historyWinLoss[positionCounter]=reducer;
                  }
               else if (OrderClosePrice()==OrderStopLoss())
                  {
                  historyWinLoss[positionCounter]=doubler;
                  }
               else 
                  {
                  historyWinLoss[positionCounter]=0; 
                  }
                  
               positionCounter--;
            }
         }
      }
   }
   
// Call appropriate Lot Calculator

   double finalLot=Lots;
  
   if (myHistoryTotal>1)
   {
      if (Martingale)
         finalLot = MartingaleLots(simpleType, historyPosition, historyWinLoss, historyLotSize);
   }   
   
   if (finalLot>100)
      finalLot=100;
   
   return (finalLot);

}


//+------------------------------------------------------------------+

// Custom Version 1.7
double MartingaleLots(int simpleType, int historyPosition[], int historyWinLoss[], double historyLotSize[]) 
{

   if (simpleType==1)
   {
      OrderSelect(historyPosition[0], SELECT_BY_POS, MODE_HISTORY);

      if (OrderType()==OP_BUY)
      {
         if (historyWinLoss[0]==-1)
            return (OrderLots()*MartingaleMultiplier);
         else if (historyWinLoss[0]==0)
            return (OrderLots());
         else 
            { return (Lots);}
      }
      else
      {
   
         OrderSelect(historyPosition[1], SELECT_BY_POS, MODE_HISTORY);
         if (OrderType()==OP_BUY)
         {
            if (historyWinLoss[1]==-1)
               return (OrderLots()*MartingaleMultiplier);
            else if (historyWinLoss[1]==0)
               return (OrderLots());
            else 
               { return (Lots);}
         }
      }
    
   }
   
   
      
      
   else if (simpleType==2)
   {
   
      OrderSelect(historyPosition[0], SELECT_BY_POS, MODE_HISTORY);

      if (OrderType()==OP_SELL)
      {
         if (historyWinLoss[0]==-1)
            return (OrderLots()*MartingaleMultiplier);
         else if (historyWinLoss[0]==0)
            return (OrderLots());
         else 
            { return (Lots);}
      }
      else
      {
   
         OrderSelect(historyPosition[1], SELECT_BY_POS, MODE_HISTORY);
         if (OrderType()==OP_SELL)
         {
            if (historyWinLoss[1]==-1)
               return (OrderLots()*MartingaleMultiplier);
            else if (historyWinLoss[1]==0)
               return (OrderLots());
            else 
               { return (Lots);}
         }
      }
    
   }
   else  
      return (Lots);


}

//+------------------------------------------------------------------+

bool newOrderPrevention(int allOrders) // Standard Version 1.7
{

   if (DisableNewOrders)
      { Comment("New Orders Disabled:  User option"); return (true); }
   else if (AccountEquity()<MinimumEquity)
      { Comment("New Orders Disabled:  Equity too low"); return (true);}
   else if (AccountBalance()<MinimumBalance)
      { Comment("New Orders Disabled:  Balance too low"); return (true);}
   else
      return (false);

}

//+------------------------------------------------------------------+

void versatileOrderTaker(int simpleType, double entryPrice) // Custom Version 1.7
{

   // Variable calculations

   double Stopvalue=0, TPvalue=0;
   int ticket, oType, slippage=3;
   string typeName;


   switch (simpleType)
   {
      case 4: 
      if (entryPrice<Bid)  { oType=OP_SELLSTOP;  typeName="SELLSTOP"; }
      if (entryPrice>Bid)  { oType=OP_SELLLIMIT; typeName="SELLLIMIT"; }
      if (Stoploss>0)      {Stopvalue = entryPrice+Stoploss*Point;}
      if (TakeProfit>0)    {TPvalue = entryPrice-TakeProfit*Point;}
      break;
         
      case 3:
      if (entryPrice>Ask)  { oType=OP_BUYSTOP;  typeName="BUYSTOP"; }
      if (entryPrice<Ask)  { oType=OP_BUYLIMIT; typeName="BUYLIMIT"; }
      if (Stoploss>0)      {Stopvalue = entryPrice-Stoploss*Point;}
      if (TakeProfit>0)    {TPvalue = entryPrice+TakeProfit*Point;}
      break;

      case 2:
      oType=OP_SELL; typeName="SELL"; 
      if (Stoploss>0)      {Stopvalue = entryPrice+Stoploss*Point;}
      if (TakeProfit>0)    {TPvalue = entryPrice-TakeProfit*Point;}
      break;

      case 1:
      oType=OP_BUY; typeName="BUY"; 
      if (Stoploss>0)      {Stopvalue = entryPrice-Stoploss*Point;}
      if (TakeProfit>0)    {TPvalue = entryPrice+TakeProfit*Point;}
      break;
      
      default:
      Print ("versatileOrderTaker has been passed an invalid SimpleType parameter: " + simpleType);
   }

   // Send Order
   
   ticket=OrderSend(Symbol(),oType,lotMaker(simpleType),entryPrice,slippage,Stopvalue,TPvalue,commentString(),simpleMagicGenerator(),0,Green);
   if (ticket>0)
     {if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(shortName + " " + typeName + " order at ",OrderOpenPrice()); }
   else 
      Print("Error opening " + typeName + " order: ",GetLastError());
}

//+------------------------------------------------------------------+


//+------------------------------------------------------------------+


//+------------------------------------------------------------------+


//+------------------------------------------------------------------+


//+------------------------------------------------------------------+

